#! /bin/sh
#
# Commit object change in branch
#
#

###set -x

myname=`basename $0`

case "$#" in
  3) object_path="$1"
     object="$2"
     branch="$3"
     shift
     shift
     shift
     ;;
  *) echo "Usage: ${myname} <path> <object> <branch>" 1>&2 
     exit 1
     ;;
esac

if test ! "${object_path}" = "" ; then
  if test ! -d ${object_path} ; then
    exit 1
  fi

  cd ${object_path}
fi

Db_tmp='.db_tmp_for_branch'

Entries=${Db_tmp}/CVS/Entries
Root=${Db_tmp}/CVS/Root
Repository=${Db_tmp}/CVS/Repository
#

if test ! -d ${Db_tmp} ; then
  mkdir ${Db_tmp}
fi

rm -f ${Db_tmp}/*.db

if test ! -d ${Db_tmp}/CVS ; then
  mkdir ${Db_tmp}/CVS
fi

#

if test -f ${Entries} ; then
  rm ${Entries}
fi

touch ${Entries}

#

if test ! -f ${Root} ; then
  cat << END >> ${Root}
${DBCVSROOT}
END
fi

#

if test -f ${Repository} ; then
  rm ${Repository}
fi

cat << END >> ${Repository}
${DBCVSROOT}/Objects/${object_path}
END

cd ${Db_tmp}

cvs -Q -d ${DBCVSROOT} update -r ${branch} ${object}
mv ../${object}.${branch} ${object}
cvs -Q -d ${DBCVSROOT} commit -m "Branch ${branch} updated" ${object}
