#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <Db.h>

DbType DbT<Ttt>New ();

/*---------------------------------------------------------------------------*/
<ttt>* Db<Ttt>ReferenceGetAddress (DbReference* reference)
/*---------------------------------------------------------------------------*/
{
  DbObject object;
  <ttt>* result;

  object = DbReferenceGetObject (reference);

  if (!DbTypeIs<Ttt> (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>ReferenceGetAddress>");
      return (NULL);
    }

  result = (<ttt>*) Db<Ttt>ObjectGetAddress (object);
  return (result);
}

/*---------------------------------------------------------------------------*/
<ttt>* Db<Ttt>ObjectLoad (char* name)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObject (name);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIs<Ttt> (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>ObjectLoad>");
      return (NULL);
    }

  return ((<ttt>*) Db<Ttt>ObjectGetAddress (object));
}

/*---------------------------------------------------------------------------*/
<ttt>* Db<Ttt>ObjectLoadByTag (char* name, char* tag)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObjectByTag (name, tag);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIs<Ttt> (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>ObjectLoad>");
      return (NULL);
    }

  return ((<ttt>*) Db<Ttt>ObjectGetAddress (object));
}

/*---------------------------------------------------------------------------*/
<ttt>* Db<Ttt>ObjectLoadByDate (char* name, char* date)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObjectByDate (name, date);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIs<Ttt> (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>ObjectLoad>");
      return (NULL);
    }

  return ((<ttt>*) Db<Ttt>ObjectGetAddress (object));
}

/*---------------------------------------------------------------------------*/
DbVector* Db<Ttt>VectorNew ()
/*---------------------------------------------------------------------------*/
{
  return (DbVectorNew (DbT<Ttt>New ()));
}

/*---------------------------------------------------------------------------*/
void Db<Ttt>VectorInit (DbVector* vector)
/*---------------------------------------------------------------------------*/
{
  DbVectorInit (vector, DbT<Ttt>New ());
}

/*---------------------------------------------------------------------------*/
<ttt>* Db<Ttt>VectorGetArray (DbVector* vector)
/*---------------------------------------------------------------------------*/
{
  <ttt>* result;
  DbType type;

  type = DbVectorGetElementType (vector);
  if (!DbTypeIs<Ttt> (type))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>VectorGetArray>");
      return (NULL);
    }

  result = (<ttt>*) DbVectorGetAddress (vector, 0);

  return (result);
}

/*---------------------------------------------------------------------------*/
<ttt> Db<Ttt>VectorGetElement (DbVector* vector, int index)
/*---------------------------------------------------------------------------*/
{
  <ttt>* result;
  DbType type;

  type = DbVectorGetElementType (vector);
  if (!DbTypeIs<Ttt> (type))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>VectorGetElement>");
      return (0);
    }

  if (index >= DbVectorGetSize (vector))
    {
      DbVectorExtend (vector, index + 1);
    }

  result = (<ttt>*) DbVectorGetAddress (vector, index);

  return (*result);
}

/*---------------------------------------------------------------------------*/
void Db<Ttt>VectorSetElement (DbVector* vector, 
                              int index, 
                              <ttt> value)
/*---------------------------------------------------------------------------*/
{
  <ttt>* result;
  DbType type;

  type = DbVectorGetElementType (vector);
  if (!DbTypeIs<Ttt> (type))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>VectorSetElement>");
      return;
    }

  if (index >= DbVectorGetSize (vector))
    {
      DbVectorExtend (vector, index + 1);
    }

  result = (<ttt>*) DbVectorGetAddress (vector, index);

  *result = value;
}

/*---------------------------------------------------------------------------*/
DbMatrix* Db<Ttt>MatrixNew (int rows, int columns)
/*---------------------------------------------------------------------------*/
{
  return (DbMatrixNew (DbT<Ttt>New (), rows, columns));
}

/*---------------------------------------------------------------------------*/
void Db<Ttt>MatrixInit (DbMatrix* matrix, int rows, int columns)
/*---------------------------------------------------------------------------*/
{
  DbMatrixInit (matrix, DbT<Ttt>New (), rows, columns);
}

/*---------------------------------------------------------------------------*/
<ttt>* Db<Ttt>MatrixGetArray (DbMatrix* matrix)
/*---------------------------------------------------------------------------*/
{
  <ttt>* result;
  DbType type;

  if (matrix == NULL) return (NULL);

  type = DbMatrixGetElementType (matrix);
  if (!DbTypeIs<Ttt> (type))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>MatrixGetArray>");
      return (NULL);
    }

  result = (<ttt>*) DbMatrixGetAddress (matrix, 0, 0);

  return (result);
}

/*---------------------------------------------------------------------------*/
<ttt> Db<Ttt>MatrixGetElement (DbMatrix* matrix, int row, int column)
/*---------------------------------------------------------------------------*/
{
  <ttt>* result;
  DbType type;

  if (matrix == NULL) return (0);

  type = DbMatrixGetElementType (matrix);
  if (!DbTypeIs<Ttt> (type))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>MatrixGetElement>");
      return (0);
    }

  result = (<ttt>*) DbMatrixGetAddress (matrix, row, column);

  return (*result);
}

/*---------------------------------------------------------------------------*/
void Db<Ttt>MatrixSetElement (DbMatrix* matrix, 
                              int row, 
                              int column, 
                              <ttt> value)
/*---------------------------------------------------------------------------*/
{
  <ttt>* result;
  DbType type;

  if (matrix == NULL) return;

  type = DbMatrixGetElementType (matrix);
  if (!DbTypeIs<Ttt> (type))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "Db<Ttt>MatrixSetElement>");
      return;
    }

  result = (<ttt>*) DbMatrixGetAddress (matrix, row, column);

  *result = value;
}

