//#include <cstdlib>
#include <stdio.h>
#include <stdlib.h>
#include "Db.h"
#include <string>
#include "CmMessage.h"
#include <iostream>
#include <cstring>

int main (void)
{
  int       i;
  int       size;
  DbString* dbStr;
  DbVector* history;
  char*     str;
  char*     newstr;
  int       err;
  int*      dummy;
  
  CmMessageOpenServer ("test");
  
  if( !(dbStr = DbStringObjectLoad ("cfg")))
    {
      DbCreateObject ("string cfg = \"\"");
      if( DbGetError () == DbErrorOk)
	{
	  printf ("DbCreateObject> %s created\n", "cfg");
	}
      else
	{
	  printf ("DbCreateObject> %s failed - %s\n", "cfg", DbGetErrorInfo ());
	}
      
      if( !(dbStr = DbStringObjectLoad ("cfg")) )
	{
	  printf("Object %s remains unavailable\n", "cfg" );
	}
    }
  

  for (size = 8 ;size < 1000; size *= 2)
    {
      newstr = (char*) malloc(size);  
      memset (newstr, 0, size);
      memset (newstr, 'A', size-1);
      
      //  printf("newstr : %s\n newstr Size : %d\n", newstr, strlen(newstr));
      
      //      printf ("lock ?\n");
      DbLockObject ("cfg");

      //      printf ("contents ?\n");
      DbStringSetContents (dbStr, newstr);

      //      printf ("commit ?\n");
      DbCommitObject ("cfg");
      //      printf ("commit \n");
      
      //      printf ("unlock ?\n");
      DbUnlockObject ("cfg");

      dbStr = DbStringObjectLoad ("cfg");

      if( DbGetError () != DbErrorOk )
	{
	  printf ("DbStringObjectLoad error\n");
	}		
      
      
      if( !(str = DbStringGetContents (dbStr)) )
	{
	  DbGetError ();
	}
      
      // printf("str : %s\n str Size : %d\n", str, strlen(str));
      
      if( (strlen (str) != strlen (newstr)) || strcmp (str,newstr) )
	{
	  printf ("String error commited %d -loaded %d\n", strlen (newstr),strlen (str));
	  for (err = i = 0; (i < strlen(str)) && (err < 10); i++ )
	    {
	      if ( str[i] == newstr[i] ) 
		continue;
	      printf (" Char %2d - %d %d\n", i, newstr[i], str[i]);
	      err++;
	    }
	}
      else
	{
	  printf ("Strings are equal!!!!\n");
	}
      
      //  history = DbGetVersionHistory("cfg");
      //  printf( "Size of string: %d -%s\n", strlen(newstr), 
      // DbStringGetContents(DbStringVectorGetElement(history, 0)) );

      printf ("String size: %d\n", strlen(newstr));
      free (newstr);
    }

  return (0);
}

